## libxml2 2.9.10%2Bdfsg

=== debian/changelog ===
libxml2 (2.9.10+dfsg-5ubuntu0.20.04.10) focal-security; urgency=medium

  * SECURITY UPDATE: OOB access in python API
    - debian/patches/CVE-2025-32414-pre1.patch: fix SAX driver with
      character streams in python/drv_libxml2.py.
    - debian/patches/CVE-2025-32414-1.patch: read at most len/4 characters
      in python/libxml.c.
    - debian/patches/CVE-2025-32414-2.patch: add a test in
      python/tests/Makefile.am, python/tests/unicode.py.
    - CVE-2025-32414
  * SECURITY UPDATE: heap under-read in xmlSchemaIDCFillNodeTables
    - debian/patches/CVE-2025-32415.patch: fix heap buffer overflow in
      xmlSchemaIDCFillNodeTables in xmlschemas.c.
    - CVE-2025-32415

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 24 Apr 2025 14:47:09 -0400

libxml2 (2.9.10+dfsg-5ubuntu0.20.04.9) focal-security; urgency=medium

  * SECURITY UPDATE: use-after-free
    - debian/patches/CVE-2024-56171.patch: Fix use-after-free after
      xmlSchemaItemListAdd.
    - CVE-2024-56171
  * SECURITY UPDATE: stack-based buffer overflow
    - debian/patches/CVE-2025-24928-pre1.patch: Check for NULL node->name
      in xmlSnprintfElements.
    - debian/patches/CVE-2025-24928.patch: Fix stack-buffer-overflow in
      xmlSnprintfElements.
    - CVE-2025-24928
  * SECURITY UPDATE: NULL pointer dereference
    - debian/patches/CVE-2025-27113.patch: Fix compilation of explicit
      child axis.
    - CVE-2025-27113

 -- Fabian Toepfer <fabian.toepfer@canonical.com>  Fri, 21 Feb 2025 15:32:54 +0100

libxml2 (2.9.10+dfsg-5ubuntu0.20.04.8) focal-security; urgency=medium

  * SECURITY UPDATE: use-after-free in xmlXIncludeAddNode
    - debian/patches/CVE-2022-49043.patch: fix UaF in xinclude.c.
    - CVE-2022-49043
  * SECURITY UPDATE: buffer overread in xmllint
    - debian/patches/CVE-2024-34459.patch: fix buffer issue when using
      htmlout option in xmllint.c.
    - CVE-2024-34459

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 28 Jan 2025 08:31:05 -0500

libxml2 (2.9.10+dfsg-5ubuntu0.20.04.7) focal-security; urgency=medium

  * SECURITY UPDATE: use-after-free via XInclude expansion
    - debian/patches/CVE-2024-25062-pre1.patch: avoid call stack overflow
      with XML reader and recursive XIncludes in xmlreader.c.
    - debian/patches/CVE-2024-25062.patch: don't expand XIncludes when
      backtracking in xmlreader.c.
    - CVE-2024-25062

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 16 Feb 2024 13:19:13 -0500

libxml2 (2.9.10+dfsg-5ubuntu0.20.04.6) focal-security; urgency=medium

  * SECURITY UPDATE: Null dereference
    - debian/patches/CVE-2023-28484-*.patch: Fix null-pointer-deref in
      xmlSchemaCheckCOSSTDerivedOK and xmlSchemaFixupComplexType
      when parsing (invalid) XML schemas in
      result/schemas/oss-fuzz-51295_0_0.err,
      test/schemas/oss-fuzz-51295_0.xml,
      test/schemas/oss-fuzz-51295_0.xsd,
      xmlschemas.c.
    - CVE-2023-28484
  * SECURITY UPDATE: Logic or memory errors and double frees
    - debian/patches/CVE-2023-29469.patch: check namelen less equal zero in
      dict.c.
    - CVE-2023-29469

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Fri, 14 Apr 2023 09:29:46 -0300

libxml2 (2.9.10+dfsg-5ubuntu0.20.04.5) focal-security; urgency=medium

  * SECURITY UPDATE: NULL pointer dereference
    - debian/patches/CVE-2022-2309.patch: reset nsNr in
      xmlCtxReset in parser.c (LP: #1996494).
    - CVE-2022-2309
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2022-40303.patch: fix integer overflows
      with XML_PARSE_HUGE in parser.c.
    - CVE-2022-40303
  * SECURITY UPDATE: Double-free
    - debian/patches/CVE-2022-40304.patch: fix dict
      corruption caused by entity ref cycles in
      entities.c.
    - CVE-2022-40304

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Wed, 30 Nov 2022 09:53:52 -0300

libxml2 (2.9.10+dfsg-5ubuntu0.20.04.4) focal-security; urgency=medium

  * SECURITY UPDATE: Possible cross-site scripting
    - debian/patches/CVE-2016-3709.patch: Revert "do not URI escape
      in server side includes" in HTMLtree.c.
    - CVE-2016-3709

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Mon, 01 Aug 2022 11:05:23 -0300

libxml2 (2.9.10+dfsg-5ubuntu0.20.04.3) focal-security; urgency=medium

  * SECURITY UPDATE: Integer overflows
    - debian/patches/CVE-2022-29824.patch: Fix integer overflows in
      xmlBuf and xmlBuffer in tree.c, buf.c.
    - CVE-2022-29824

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Tue, 10 May 2022 11:13:24 -0300

libxml2 (2.9.10+dfsg-5ubuntu0.20.04.2) focal-security; urgency=medium

  * SECURITY UPDATE: use-after-free of ID and IDREF attributes
    - debian/patches/CVE-2022-23308.patch: normalize ID attributes in
      valid.c.
    - CVE-2022-23308

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 10 Mar 2022 12:59:13 -0500

libxml2 (2.9.10+dfsg-5ubuntu0.20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: out-of-bounds read
    - debian/patches/CVE-2020-24977.patch: Make sure that truncated UTF-8
      sequences don't cause an out-of-bounds array access in xmllint.
    - CVE-2020-24977
  * SECURITY UPDATE: use-after-free in xmlEncodeEntitiesInternal
    - debian/patches/CVE-2021-3516.patch: Call htmlCtxtUseOptions to make sure
      that names aren't stored in dictionaries.
    - CVE-2021-3516
  * SECURITY UPDATE: heap-based buffer overflow in xmlEncodeEntitiesInternal 
    - debian/patches/CVE-2021-3517.patch: Add some checks to validate input is
      UTF-8 format, supplementing CVE-2020-24977 fix.
    - CVE-2021-3517
  * SECURITY UPDATE: use-after-free in xmlXIncludeDoProcess 
    - debian/patches/CVE-2021-3518.patch: Move from a block list to an allow
      list approach to avoid descending into other node types that can't
      contain elements.
    - CVE-2021-3518
  * SECURITY UPDATE: NULL pointer dereference in xmlValidBuildAContentModel
    - debian/patches/CVE-2021-3537.patch: Check return value of recursive calls


## libxml2 2.9.10+dfsg

=== debian/changelog ===
libxml2 (2.9.10+dfsg-1ubuntu3) focal; urgency=medium

  * debian/patches/0001-Check-the-type-of-each-node-in-xmlFreeNodeList-
    not-j.patch: Check the type of each node in xmlFreeNodeList, not just
    the parent node.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 22 Feb 2020 23:58:06 -0800

libxml2 (2.9.10+dfsg-1ubuntu2) focal; urgency=medium

  * Restore the old xml2-config behaviour to print the shared libs by default.
    xml2-config --libs --static still can be used for the private libs.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 20 Feb 2020 10:56:09 +0100

libxml2 (2.9.10+dfsg-1ubuntu1) focal; urgency=medium

  * Restore the xml2-config binary for now.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 09:41:38 +0100

=== debian/control ===
Source: libxml2
Priority: optional
Section: libs
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>
Uploaders:
 Aron Xu <aron@debian.org>,
 YunQiang Su <wzssyqa@gmail.com>,
Build-Depends:
 debhelper-compat (= 12),
 dh-python <!nopython>,
 libicu-dev,
 liblzma-dev,
 libpython3-all-dbg <!nopython>,
 libpython3-all-dev <!nopython>,
 pkg-config,
 python3-all-dbg:any <!nopython>,
 python3-all-dev:any (>= 3.5) <!nopython>,
 rename,
 zlib1g-dev | libz-dev,
Standards-Version: 4.4.1
Rules-Requires-Root: no
Homepage: http://xmlsoft.org
Vcs-Git: https://salsa.debian.org/xml-sgml-team/libxml2.git
Vcs-Browser: https://salsa.debian.org/xml-sgml-team/libxml2

Package: libxml2
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 This package provides a library providing an extensive API to handle
 such XML data files.

Package: libxml2-utils
Architecture: any
Section: text
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: foreign
Description: XML utilities
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 This package provides xmllint, a tool for validating and reformatting
 XML documents, and xmlcatalog, a tool to parse and manipulate XML or
 SGML catalog files.

Package: libxml2-dev
Architecture: any
Section: libdevel
Depends:
 libicu-dev,
 libxml2 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 pkg-config,
Multi-Arch: same
Description: Development files for the GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 Install this package if you wish to develop your own programs using
 the GNOME XML library.

Package: libxml2-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Suggests:
 devhelp,
Multi-Arch: foreign
Description: Documentation for the GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 This package contains general information about the GNOME XML library
 and more specific API references.

Package: python3-libxml2
Architecture: any
Build-Profiles: <!nopython>
Section: python
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python3 bindings for the GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 This package contains the files needed to use the GNOME XML library
 in Python3 programs.

Package: python3-libxml2-dbg
Architecture: any
Build-Profiles: <!nopython>
Section: debug
Multi-Arch: same
Depends:
 python3-libxml2 (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python3 bindings for the GNOME XML library (debug extension)
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 This package contains the files needed to use the GNOME XML library
 in Python3 programs for use with the Python3 debug interpreter.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

DOPACKAGES = $(shell dh_listpackages)

ifneq (,$(filter python3-libxml2 python3-libxml2-dbg,$(DOPACKAGES)))
# The versions of python3 currently supported
PY3VERS=$(shell py3versions -s)
else
PY3VERS=
endif

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -O3
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

TARGETS := main $(PYVERS) $(PYVERS:%=%-dbg) $(PY3VERS) $(PY3VERS:%=%-dbg)

CONFIGURE_FLAGS := --disable-silent-rules --with-history --cache-file="$(CURDIR)/builddir/config.cache"

override_dh_auto_configure: $(TARGETS:%=doconfigure-%)

doconfigure-%:
	dh_auto_configure --parallel --builddirectory=builddir/$(*) -- $(CONFIGURE_FLAGS)
	touch $@

doconfigure-main: CONFIGURE_FLAGS += --without-python --with-icu
doconfigure-python%: CONFIGURE_FLAGS += --with-python=/usr/bin/$(subst -dbg,,$(*)) --with-python-install-dir=/usr/lib/$(subst -dbg,,$(*))/dist-packages

dobuild-%: BUILD_DIR=builddir/$(*)
dobuild-%: doconfigure-%
	$(if $(filter $(BUILD_DIR),builddir/$(*)),,[ -d $(BUILD_DIR) ] || mv builddir/$(*)/python $(BUILD_DIR))
	dh_auto_build --parallel --builddirectory=$(BUILD_DIR) -- $(BUILD_FLAGS)

dobuild-python%: BUILD_DIR=builddir/main/$(*)
dobuild-python%: BUILD_FLAGS=libxml2mod_la_LIBADD='$$(mylibs)' \
    PYTHON_INCLUDES='$(shell $(DEB_HOST_GNU_TYPE)-$(*)-config --includes)' \
    PYTHON_LIBS='$(shell $(DEB_HOST_GNU_TYPE)-$(*)-config --ldflags)'
dobuild-python%-dbg: BUILD_FLAGS+=PYTHON_INCLUDES='$(shell $(DEB_HOST_GNU_TYPE)-$(*)-config --includes)' \
    PYTHON_LIBS='$(shell $(DEB_HOST_GNU_TYPE)-$(*)-config --ldflags)' \
    CFLAGS='$(CFLAGS) -Wall -g -O0' CPPFLAGS='$(CPPFLAGS)' LDFLAGS='$(LDFLAGS) \
    -L$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)'

override_dh_auto_build-arch: $(TARGETS:%=dobuild-%)
override_dh_auto_build-indep: dobuild-main

override_dh_auto_clean:
	rm -rf builddir debian/tmp-dbg
	rm -f doconfigure-*
	dh_auto_clean

doinstall-main:
	dh_auto_install --builddirectory=builddir/main
	mv debian/tmp/usr/share/aclocal/libxml.m4 debian/tmp/usr/share/aclocal/libxml2.m4

override_dh_auto_install-arch: $(TARGETS:%=doinstall-%)
	find debian/tmp -name *.la -delete

override_dh_auto_install-indep: doinstall-main
	find debian/tmp -name *.la -delete
	# Properly install documentation in /usr/share/doc/libxml2-doc
	install -d debian/tmp/usr/share/doc/libxml2-doc/examples
	install -m 644 \
		doc/*.html \
		doc/*.gif \
		doc/*.png \
		doc/libxml2-api.xml debian/tmp/usr/share/doc/libxml2-doc
	install -m 644 \
		doc/examples/*.c \
		doc/examples/*.res \
		doc/examples/index.html \
		doc/examples/[tw]*.xml debian/tmp/usr/share/doc/libxml2-doc/examples
	cp -a \
		doc/html \
		doc/tutorial debian/tmp/usr/share/doc/libxml2-doc

doinstall-python%-dbg:
	$(MAKE) -C builddir/main/python$(*)-dbg DESTDIR=$(CURDIR)/debian/tmp-dbg install-pythonLTLIBRARIES
	rename -v -f 's/(?<!_d)\.so$$/_d.so/' debian/tmp-dbg/usr/lib/python$(*)/*-packages/*.so

doinstall-python%:
	dh_auto_install --builddirectory=builddir/main/python$(*)

override_dh_compress:
	dh_compress -Xexamples/ -Xtutorial/ -Xhtml/ -X.html

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS

override_dh_install-arch:
	dh_install -Npython3-libxml2-dbg
ifneq (,$(filter python3-libxml2-dbg,$(DOPACKAGES)))
	dh_install -ppython3-libxml2-dbg --sourcedir=debian/tmp-dbg
endif

override_dh_strip:
ifneq (,$(filter python3-libxml2 python3-libxml2-dbg,$(DOPACKAGES)))
	dh_strip -ppython3-libxml2 --dbg-package=python3-libxml2-dbg
endif
	# Do not strip the python*-*-dbg packages, the python-dbg interpreter likes them
	dh_strip --remaining-packages -Npython3-libxml2-dbg

override_dh_makeshlibs:
	dh_makeshlibs -a -V 'libxml2 (>= 2.9.8)' -- -c4

%:
	dh $@ \
		$(if $(filter python3-libxml2 python3-libxml2-dbg,$(DOPACKAGES)),--with python3)

=== debian/tests/control ===
Tests: build python2 python3
Depends: libxml2-dev, python-libxml2, python3-libxml2, build-essential, pkg-config

## libxml2 2.9.12+dfsg

=== debian/changelog ===
libxml2 (2.9.12+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Add a few patches from upstream:
    + Work around lxml API abuse.
    + Fix regression in xmlNodeDumpOutputInternal.  LP: #1943277
    + Fix whitespace when serializing empty HTML documents.
    + Forbid epsilon-reduction of final states.
    + Fix buffering in xmlOutputBufferWrite.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 10 Sep 2021 22:13:09 +0200

libxml2 (2.9.12+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Add patch from upstream to fix a regression in the recursion limit for
    complex XSLT documents.  This also fixed the ruby-nokogiri test failure,
    so drop the previously introduced Breaks.
  * d/control: Bump Standards-Version to 4.6.0, no changes needed.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 01 Sep 2021 16:45:21 +0200

libxml2 (2.9.12+dfsg-2) experimental; urgency=medium

  * Team upload.
  * d/control: Break ruby-nokogiri (<< 1.11.7).
  * lintian:
    + Add a link from usr/share/doc/libxml2/gtk-doc
      usr/share/gtk-doc/html/libxml2.  See #970275
    + Override for package-contains-documentation-outside-usr-share-doc.
  * Add two patches to refactor how docs are installed.
  * Add a patch to properly install all the documentation we were
    previously manually installing.
  * d/rules: Use the now working --docdir flag to install the documentation
    directly in the right place.
  * Move the documentation and examples from /usr/share/doc/libxml2-doc
    to /usr/share/doc/libxml2/, following Policy v3.9.7 §12.3.

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 29 Jul 2021 12:22:11 +0200

libxml2 (2.9.12+dfsg-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 2.9.12+dfsg.
  * Drop patches applied upstream.
  * d/libxml2.symbols: Add a new symbol.
  * d/control: Bump Standards-Version to 4.5.1, no changes needed.
  * d/rules:
    + Bump shlibs version.
    + Drop the --as-needed linking flag, the default starting from bullseye.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 18 Jul 2021 15:33:26 +0200

libxml2 (2.9.10+dfsg-6.7) unstable; urgency=medium

  * Non-maintainer upload.
  * Patch for security issue CVE-2021-3541 (Closes: #988603)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 22 May 2021 08:21:29 +0200

libxml2 (2.9.10+dfsg-6.6) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable.

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 06 May 2021 10:48:16 +0200

libxml2 (2.9.10+dfsg-6.5) experimental; urgency=medium

  * Non-maintainer upload.
  * Propagate error in xmlParseElementChildrenContentDeclPriv (CVE-2021-3537)
    (Closes: #988123)

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 06 May 2021 10:28:10 +0200

libxml2 (2.9.10+dfsg-6.4) experimental; urgency=medium

  * Non-maintainer upload.
  * Fix use-after-free with `xmllint --html --push` (CVE-2021-3516)
    (Closes: #987739)
  * Validate UTF8 in xmlEncodeEntities (CVE-2021-3517) (Closes: #987738)
  * Fix user-after-free with `xmllint --xinclude --dropdtd` (CVE-2021-3518)
    (Closes: #987737)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 02 May 2021 16:23:29 +0200

libxml2 (2.9.10+dfsg-6.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove the Python2 autopkg test.

 -- Matthias Klose <doko@debian.org>  Sun, 29 Nov 2020 11:58:00 +0100

libxml2 (2.9.10+dfsg-6.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix out-of-bounds read with 'xmllint --htmlout' (CVE-2020-24977)
    (Closes: #969529)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 25 Oct 2020 13:56:23 +0100

libxml2 (2.9.10+dfsg-6.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build with Python 3.9. Closes: #972022.

 -- Matthias Klose <doko@debian.org>  Wed, 14 Oct 2020 08:45:25 +0200

libxml2 (2.9.10+dfsg-6) unstable; urgency=medium

  * Team upload.

  [ Mattia Rizzolo ]
  * Drop Python2 support.  Closes: #936941
  * Use dh-sequence-python3 to at least simplify one line of d/rules.
  * Bump debhelper compat level to 13.
    + Drop dh_missing override, dh13 defaults to --fail-missing.

  [ Debian Janitor ]
  * Use correct machine-readable copyright file URI.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Rely on pre-initialized dpkg-architecture variables.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 04 Sep 2020 23:05:12 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: libxml2
 Priority: optional
 Section: libs
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>
+Maintainer: Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>
 Uploaders:
  Aron Xu <aron@debian.org>,
  YunQiang Su <wzssyqa@gmail.com>,
 Build-Depends:
- debhelper-compat (= 12),
- dh-python <!nopython>,
+ debhelper-compat (= 13),
+Build-Depends-Indep:
+ pkg-config,
+Build-Depends-Arch:
+ dh-sequence-python3 <!nopython>,
  libicu-dev,
  liblzma-dev,
  libpython3-all-dbg <!nopython>,
@@ -18,7 +20,7 @@
  python3-all-dev:any (>= 3.5) <!nopython>,
  rename,
  zlib1g-dev | libz-dev,
-Standards-Version: 4.4.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: http://xmlsoft.org
 Vcs-Git: https://salsa.debian.org/xml-sgml-team/libxml2.git

=== debian/rules ===
--- 
+++ 
@@ -12,19 +12,20 @@
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 export DEB_CFLAGS_MAINT_APPEND = -Wall -O3
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
-DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
-DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+include /usr/share/dpkg/architecture.mk
 
 TARGETS := main $(PYVERS) $(PYVERS:%=%-dbg) $(PY3VERS) $(PY3VERS:%=%-dbg)
 
-CONFIGURE_FLAGS := --disable-silent-rules --with-history --cache-file="$(CURDIR)/builddir/config.cache"
+CONFIGURE_FLAGS := --with-history --cache-file="$(CURDIR)/builddir/config.cache"
 
-override_dh_auto_configure: $(TARGETS:%=doconfigure-%)
+override_dh_auto_configure-arch: $(TARGETS:%=doconfigure-%)
+
+override_dh_auto_configure-indep:
+	dh_auto_configure -- --docdir \$${prefix}/share/doc/libxml2 --enable-rebuild-docs --without-python
 
 doconfigure-%:
-	dh_auto_configure --parallel --builddirectory=builddir/$(*) -- $(CONFIGURE_FLAGS)
+	dh_auto_configure --builddirectory=builddir/$(*) -- $(CONFIGURE_FLAGS)
 	touch $@
 
 doconfigure-main: CONFIGURE_FLAGS += --without-python --with-icu
@@ -33,7 +34,7 @@
 dobuild-%: BUILD_DIR=builddir/$(*)
 dobuild-%: doconfigure-%
 	$(if $(filter $(BUILD_DIR),builddir/$(*)),,[ -d $(BUILD_DIR) ] || mv builddir/$(*)/python $(BUILD_DIR))
-	dh_auto_build --parallel --builddirectory=$(BUILD_DIR) -- $(BUILD_FLAGS)
+	dh_auto_build --builddirectory=$(BUILD_DIR) -- $(BUILD_FLAGS)
 
 dobuild-python%: BUILD_DIR=builddir/main/$(*)
 dobuild-python%: BUILD_FLAGS=libxml2mod_la_LIBADD='$$(mylibs)' \
@@ -45,7 +46,12 @@
     -L$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)'
 
 override_dh_auto_build-arch: $(TARGETS:%=dobuild-%)
-override_dh_auto_build-indep: dobuild-main
+
+override_dh_auto_build-indep:
+	dh_auto_build -i
+
+override_dh_auto_test-indep:
+	: Skipping tests during indep build
 
 override_dh_auto_clean:
 	rm -rf builddir debian/tmp-dbg
@@ -59,23 +65,9 @@
 override_dh_auto_install-arch: $(TARGETS:%=doinstall-%)
 	find debian/tmp -name *.la -delete
 
-override_dh_auto_install-indep: doinstall-main
-	find debian/tmp -name *.la -delete
-	# Properly install documentation in /usr/share/doc/libxml2-doc
-	install -d debian/tmp/usr/share/doc/libxml2-doc/examples
-	install -m 644 \
-		doc/*.html \
-		doc/*.gif \
-		doc/*.png \
-		doc/libxml2-api.xml debian/tmp/usr/share/doc/libxml2-doc
-	install -m 644 \
-		doc/examples/*.c \
-		doc/examples/*.res \
-		doc/examples/index.html \
-		doc/examples/[tw]*.xml debian/tmp/usr/share/doc/libxml2-doc/examples
-	cp -a \
-		doc/html \
-		doc/tutorial debian/tmp/usr/share/doc/libxml2-doc
+override_dh_auto_install-indep:
+	dh_auto_install -i
+	rm -v debian/tmp/usr/share/doc/libxml2/Copyright
 
 doinstall-python%-dbg:
 	$(MAKE) -C builddir/main/python$(*)-dbg DESTDIR=$(CURDIR)/debian/tmp-dbg install-pythonLTLIBRARIES
@@ -95,6 +87,7 @@
 ifneq (,$(filter python3-libxml2-dbg,$(DOPACKAGES)))
 	dh_install -ppython3-libxml2-dbg --sourcedir=debian/tmp-dbg
 endif
+	sed -i -e 's,/lib/$(DEB_HOST_MULTIARCH),/lib,' debian/libxml2-dev/usr/bin/xml2-config
 
 override_dh_strip:
 ifneq (,$(filter python3-libxml2 python3-libxml2-dbg,$(DOPACKAGES)))
@@ -104,8 +97,18 @@
 	dh_strip --remaining-packages -Npython3-libxml2-dbg
 
 override_dh_makeshlibs:
-	dh_makeshlibs -a -V 'libxml2 (>= 2.9.8)' -- -c4
+	dh_makeshlibs -plibxml2 -V 'libxml2 (>= 2.9.11)' -- -c4
+	dh_makeshlibs --remaining-packages
 
-%:
-	dh $@ \
-		$(if $(filter python3-libxml2 python3-libxml2-dbg,$(DOPACKAGES)),--with python3)
+
+#  I need to specify all the targets (build, binary, clean, etc) as
+#  otherwise dh may invoke them in a order that is not appropriate for the
+#  build system (the -indep part is done in-tree because rebuilding the
+#  docs out of tree is not supported.  And once an in-tree build is done no
+#  out-of-tree builds can't be done, so we wouldn't be able to do the -arch
+#  builds after the -indep one).
+clean build-arch binary-arch build-indep binary-indep:
+	dh $@
+
+build: build-arch build-indep
+binary: binary-arch binary-indep

## libxml2 2.9.13%2Bdfsg

=== debian/changelog ===
libxml2 (2.9.13+dfsg-1ubuntu0.1) jammy-security; urgency=medium

  * SECURITY UPDATE: Integer overflows
    - debian/patches/CVE-2022-29824.patch: Fix integer overflows in
      xmlBuf and xmlBuffer in tree.c, buf.c.
    - CVE-2022-29824

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Mon, 09 May 2022 15:33:11 -0300

libxml2 (2.9.13+dfsg-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 17 Mar 2022 19:28:02 +0000

libxml2 (2.9.13+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.9.13+dfsg.
    + Convert devhelp to version2.  Closes: #955205
    + Use-after-free of ID and IDREF attrs.  CVE-2022-23308; Closes: #1006489
  * Bump my copyright for debian/*.
  * d/watch: move download sourceto https://download.gnome.org/.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 27 Feb 2022 19:57:48 +0100

libxml2 (2.9.12+dfsg-6) unstable; urgency=medium

  * Team upload.
  * d/control:
    + Use the new Description field in the source paragraph and add references
      to the binary paragraphs.  This is a new feature since dpkg 1.19.0
      (from 2017).  Policy is not yet updated, see #998165.
    + Drop Build-Depends on python3-all-dbg, not used since the last revision.
  * Add patches from upstream to fix:
    + return code of xmllint when incorrectly called.  Closes: #727075
    + regression with entity references in external DTDs.  Closes: #994765

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 19 Feb 2022 13:11:26 +0100

libxml2 (2.9.12+dfsg-5) unstable; urgency=medium

  * Team upload.
  * Stop building the python3-libxml2-dbg package.  Closes: #994307
  * Add a Conflicts against the old w3c-dtd-xhtml, that contains a .dtd that
    is not validating anymore.  Closes: #993638
  * Remove lintian override that was fixed in lintian for
    debian-rules-uses-supported-python-versions-without-python-all-build-depends

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 20 Sep 2021 15:06:01 +0200

## libxml2 2.9.13+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

file(STRINGS "configure.ac" CONFIGURE_AC_LINES)
foreach(line ${CONFIGURE_AC_LINES})
	if(line MATCHES [[^m4_define\(\[(MAJOR_VERSION|MINOR_VERSION|MICRO_VERSION)\],[ \t]*([0-9]+)\)$]])
		set(LIBXML_${CMAKE_MATCH_1} ${CMAKE_MATCH_2})
	elseif(line MATCHES "^(LIBXML_MAJOR_VERSION|LIBXML_MINOR_VERSION|LIBXML_MICRO_VERSION)=([0-9]+)$")
		set(${CMAKE_MATCH_1} ${CMAKE_MATCH_2})
	endif()
endforeach()
set(VERSION "${LIBXML_MAJOR_VERSION}.${LIBXML_MINOR_VERSION}.${LIBXML_MICRO_VERSION}")

project(libxml2 VERSION ${VERSION} LANGUAGES C)

include(CheckCSourceCompiles)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckStructHasMember)
include(CheckSymbolExists)
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

option(BUILD_SHARED_LIBS "Build shared libraries" ON)
set(LIBXML2_WITH_AUTOMATA ON)
option(LIBXML2_WITH_C14N "Add the Canonicalization support" ON)
option(LIBXML2_WITH_CATALOG "Add the Catalog support" ON)
option(LIBXML2_WITH_DEBUG "Add the debugging module" ON)
option(LIBXML2_WITH_DOCB "Add Docbook SGML support" ON)
set(LIBXML2_WITH_EXPR ON)
option(LIBXML2_WITH_FTP "Add the FTP support" ON)
option(LIBXML2_WITH_HTML "Add the HTML support" ON)
option(LIBXML2_WITH_HTTP "Add the HTTP support" ON)
option(LIBXML2_WITH_ICONV "Add ICONV support" ON)
option(LIBXML2_WITH_ICU "Add ICU support" OFF)
option(LIBXML2_WITH_ISO8859X "Add ISO8859X support if no iconv" ON)
option(LIBXML2_WITH_LEGACY "Add deprecated APIs for compatibility" ON)
option(LIBXML2_WITH_LZMA "Use liblzma" ON)
option(LIBXML2_WITH_MEM_DEBUG "Add the memory debugging module" OFF)
option(LIBXML2_WITH_MODULES "Add the dynamic modules support" ON)
option(LIBXML2_WITH_OUTPUT "Add the serialization support" ON)
option(LIBXML2_WITH_PATTERN "Add the xmlPattern selection interface" ON)
option(LIBXML2_WITH_PROGRAMS "Build programs" ON)
option(LIBXML2_WITH_PUSH "Add the PUSH parser interfaces" ON)
option(LIBXML2_WITH_PYTHON "Build Python bindings" ON)
option(LIBXML2_WITH_READER "Add the xmlReader parsing interface" ON)
option(LIBXML2_WITH_REGEXPS "Add Regular Expressions support" ON)
option(LIBXML2_WITH_RUN_DEBUG "Add the runtime debugging module" OFF)
option(LIBXML2_WITH_SAX1 "Add the older SAX1 interface" ON)
option(LIBXML2_WITH_SCHEMAS "Add Relax-NG and Schemas support" ON)
option(LIBXML2_WITH_SCHEMATRON "Add Schematron support" ON)
option(LIBXML2_WITH_TESTS "Build tests" ON)
option(LIBXML2_WITH_THREADS "Add multithread support" ON)
option(LIBXML2_WITH_THREAD_ALLOC "Add per-thread memory" OFF)
option(LIBXML2_WITH_TREE "Add the DOM like tree manipulation APIs" ON)
set(LIBXML2_WITH_TRIO OFF)
set(LIBXML2_WITH_UNICODE ON)
option(LIBXML2_WITH_VALID "Add the DTD validation support" ON)
option(LIBXML2_WITH_WRITER "Add the xmlWriter saving interface" ON)
option(LIBXML2_WITH_XINCLUDE "Add the XInclude support" ON)
option(LIBXML2_WITH_XPATH "Add the XPATH support" ON)
option(LIBXML2_WITH_XPTR "Add the XPointer support" ON)
option(LIBXML2_WITH_ZLIB "Use libz" ON)
set(LIBXML2_XMLCONF_WORKING_DIR ${CMAKE_CURRENT_BINARY_DIR} CACHE PATH "Working directory for XML Conformance Test Suite")

if(LIBXML2_WITH_ICONV)
	find_package(Iconv REQUIRED)
endif()

if(LIBXML2_WITH_ICU)
	find_package(ICU REQUIRED COMPONENTS data i18n uc)
endif()

if(LIBXML2_WITH_LZMA)
	find_package(LibLZMA REQUIRED)
endif()

if(LIBXML2_WITH_PYTHON)
	check_include_files(unistd.h HAVE_UNISTD_H)
	check_symbol_exists(F_GETFL fcntl.h HAVE_F_GETFL)
	if(HAVE_UNISTD_H AND HAVE_F_GETFL)
		find_package(Python COMPONENTS Interpreter Development REQUIRED)
	else()
		find_package(Python2 COMPONENTS Interpreter Development REQUIRED)
		add_library(Python::Python ALIAS Python2::Python)
		set(Python_EXECUTABLE ${Python2_EXECUTABLE})
		set(Python_SITEARCH ${Python2_SITEARCH})
	endif()
	set(LIBXML2_PYTHON_INSTALL_DIR ${Python_SITEARCH} CACHE PATH "Python bindings install directory")
endif()

if(LIBXML2_WITH_THREADS)
	find_package(Threads REQUIRED)
endif()

if(LIBXML2_WITH_ZLIB)
	find_package(ZLIB REQUIRED)
endif()

foreach(VARIABLE IN ITEMS WITH_AUTOMATA WITH_C14N WITH_CATALOG WITH_DEBUG WITH_DOCB WITH_EXPR WITH_FTP WITH_HTML WITH_HTTP WITH_ICONV WITH_ICU WITH_ISO8859X WITH_LEGACY WITH_LZMA WITH_MEM_DEBUG WITH_MODULES WITH_OUTPUT WITH_PATTERN WITH_PUSH WITH_READER WITH_REGEXPS WITH_RUN_DEBUG WITH_SAX1 WITH_SCHEMAS WITH_SCHEMATRON WITH_THREADS WITH_THREAD_ALLOC WITH_TREE WITH_TRIO WITH_UNICODE WITH_VALID WITH_WRITER WITH_XINCLUDE WITH_XPATH WITH_XPTR WITH_ZLIB)
	if(LIBXML2_${VARIABLE})
		set(${VARIABLE} 1)
	else()
		set(${VARIABLE} 0)
	endif()
endforeach()

set(LIBXML_VERSION ${LIBXML_MAJOR_VERSION}0${LIBXML_MINOR_VERSION}0${LIBXML_MICRO_VERSION})
set(LIBXML_VERSION_STRING "${LIBXML_VERSION}")
set(LIBXML_VERSION_EXTRA "")
set(LIBXML_VERSION_NUMBER ${LIBXML_VERSION})

set(MODULE_EXTENSION "${CMAKE_SHARED_LIBRARY_SUFFIX}")

set(PACKAGE "libxml2")
set(PACKAGE_BUGREPORT "xml@gnome.org")
set(PACKAGE_NAME "libxml2")
set(PACKAGE_STRING "libxml2 ${VERSION}")
set(PACKAGE_TARNAME "libxml2")
set(PACKAGE_URL "https://gitlab.gnome.org/GNOME/libxml2")
set(PACKAGE_VERSION ${VERSION})

if(LIBLZMA_FOUND)
	list(APPEND CMAKE_REQUIRED_LIBRARIES LibLZMA::LibLZMA)
endif()

if(Threads_FOUND)
	list(APPEND CMAKE_REQUIRED_LIBRARIES Threads::Threads)
endif()

if(ZLIB_FOUND)
	list(APPEND CMAKE_REQUIRED_LIBRARIES ZLIB::ZLIB)
endif()

if(MSVC)
	configure_file(include/win32config.h config.h COPYONLY)
else()
	check_c_source_compiles("
		void __attribute__((destructor))
		f(void) {}
		int main(void) { return 0; }
	" HAVE_ATTRIBUTE_DESTRUCTOR)
	if(HAVE_ATTRIBUTE_DESTRUCTOR)
		set(ATTRIBUTE_DESTRUCTOR "__attribute__((destructor))")
	endif()
	check_c_source_compiles("
		#include <netdb.h>
		int main() { (void) gethostbyname((const char*) \"\"); return 0; }
	" GETHOSTBYNAME_ARG_CAST_CONST)
	if(NOT GETHOSTBYNAME_ARG_CAST_CONST)
		set(GETHOSTBYNAME_ARG_CAST "(char *)")
	else()
		set(GETHOSTBYNAME_ARG_CAST "/**/")
	endif()
	check_include_files(arpa/inet.h HAVE_ARPA_INET_H)
	check_include_files(arpa/nameser.h HAVE_ARPA_NAMESER_H)
	check_struct_has_member("struct sockaddr_storage" ss_family "sys/socket.h;sys/types.h" HAVE_SS_FAMILY)
	check_struct_has_member("struct sockaddr_storage" __ss_family "sys/socket.h;sys/types.h" HAVE_BROKEN_SS_FAMILY)
	if(HAVE_BROKEN_SS_FAMILY)
		set(ss_family __ss_family)
	endif()
	check_function_exists(class HAVE_CLASS)
	check_include_files(ctype.h HAVE_CTYPE_H)
	check_include_files(dlfcn.h HAVE_DLFCN_H)
	check_library_exists(dl dlopen "" HAVE_DLOPEN)
	check_include_files(dl.h HAVE_DL_H)
	check_include_files(errno.h HAVE_ERRNO_H)
	check_include_files(fcntl.h HAVE_FCNTL_H)
	check_include_files(float.h HAVE_FLOAT_H)
	check_function_exists(fpclass HAVE_FPCLASS)
	check_function_exists(fprintf HAVE_FPRINTF)
	check_function_exists(ftime HAVE_FTIME)
	check_function_exists(getaddrinfo HAVE_GETADDRINFO)
	check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
	check_include_files(inttypes.h HAVE_INTTYPES_H)
	check_function_exists(isascii HAVE_ISASCII)
	check_library_exists(history append_history "" HAVE_LIBHISTORY)
	check_library_exists(readline readline "" HAVE_LIBREADLINE)
	check_include_files(limits.h HAVE_LIMITS_H)
	check_function_exists(localtime HAVE_LOCALTIME)
	check_include_files(malloc.h HAVE_MALLOC_H)
	check_include_files(math.h HAVE_MATH_H)
	check_function_exists(mmap HAVE_MMAP)
	check_function_exists(munmap HAVE_MUNMAP)
	check_include_files(netdb.h HAVE_NETDB_H)
	check_include_files(netinet/in.h HAVE_NETINET_IN_H)
	check_include_files(poll.h HAVE_POLL_H)
	check_function_exists(printf HAVE_PRINTF)
	check_include_files(pthread.h HAVE_PTHREAD_H)
	check_function_exists(putenv HAVE_PUTENV)
	check_function_exists(rand HAVE_RAND)
	check_function_exists(rand_r HAVE_RAND_R)
	check_include_files(resolv.h HAVE_RESOLV_H)
	check_library_exists(dld shl_load "" HAVE_SHLLOAD)
	check_include_files(signal.h HAVE_SIGNAL_H)
	check_function_exists(snprintf HAVE_SNPRINTF)
	check_function_exists(sprintf HAVE_SPRINTF)
	check_function_exists(srand HAVE_SRAND)
	check_function_exists(sscanf HAVE_SSCANF)
	check_function_exists(stat HAVE_STAT)
	check_include_files(stdarg.h HAVE_STDARG_H)
	check_include_files(stdint.h HAVE_STDINT_H)
	check_include_files(stdlib.h HAVE_STDLIB_H)
	check_function_exists(strftime HAVE_STRFTIME)
	check_include_files(strings.h HAVE_STRINGS_H)
	check_include_files(string.h HAVE_STRING_H)
	check_include_files(sys/mman.h HAVE_SYS_MMAN_H)
	check_include_files(sys/select.h HAVE_SYS_SELECT_H)
	check_include_files(sys/socket.h HAVE_SYS_SOCKET_H)
	check_include_files(sys/stat.h HAVE_SYS_STAT_H)
	check_include_files(sys/timeb.h HAVE_SYS_TIMEB_H)
	check_include_files(sys/time.h HAVE_SYS_TIME_H)
	check_include_files(sys/types.h HAVE_SYS_TYPES_H)
	check_function_exists(time HAVE_TIME)
	check_include_files(time.h HAVE_TIME_H)
	check_include_files(unistd.h HAVE_UNISTD_H)
	check_function_exists(va_copy HAVE_VA_COPY)
	check_function_exists(vfprintf HAVE_VFPRINTF)
	check_function_exists(vsnprintf HAVE_VSNPRINTF)
	check_function_exists(vsprintf HAVE_VSPRINTF)
	check_function_exists(__va_copy HAVE___VA_COPY)
	check_c_source_compiles("
		#include <stdlib.h>
		#include <iconv.h>
		extern
		#ifdef __cplusplus
		\"C\"
		#endif
		#if defined(__STDC__) || defined(__cplusplus)
		size_t iconv(iconv_t cd, char** inbuf, size_t* inbytesleft, char** outbuf, size_t* outbytesleft);
		#else
		size_t iconv();
		#endif
		int main() { return 0; }
	" ICONV_CONST_TEST)
	if(NOT ICONV_CONST_TEST)
		set(ICONV_CONST "const")
	endif()
	set(LT_OBJDIR ".libs/")
	check_c_source_compiles("
		#include <sys/socket.h>
		#include <sys/types.h>
		int main() { (void) send(1, (const char*) \"\", 1, 1); return 0; }
	" SEND_ARG2_CAST_CONST)
	if(NOT SEND_ARG2_CAST_CONST)
		set(SEND_ARG2_CAST "(char *)")
	else()
		set(SEND_ARG2_CAST "/**/")
	endif()
	check_include_files("float.h;stdarg.h;stdlib.h;string.h" STDC_HEADERS)
	check_c_source_compiles("
		#include <stdarg.h>
		void a(va_list* ap) {};
		int main() { va_list ap1, ap2; a(&ap1); ap2 = (va_list) ap1; return 0; }
	" VA_LIST_IS_ARRAY_TEST)
	if(VA_LIST_IS_ARRAY_TEST)
		set(VA_LIST_IS_ARRAY FALSE)
	else()
		set(VA_LIST_IS_ARRAY TRUE)
	endif()
	check_c_source_compiles("
		#include <stddef.h>
		#include <sys/socket.h>
		#include <sys/types.h>
		int main() { (void) getsockopt(1, 1, 1, NULL, (socklen_t*) NULL); return 0; }
	" XML_SOCKLEN_T_SOCKLEN_T)
	if(XML_SOCKLEN_T_SOCKLEN_T)
		set(XML_SOCKLEN_T socklen_t)
	else()
		check_c_source_compiles("
			#include <stddef.h>
			#include <sys/socket.h>
			#include <sys/types.h>
			int main() { (void) getsockopt(1, 1, 1, NULL, (size_t*) NULL); return 0; }
		" XML_SOCKLEN_T_SIZE_T)
		if(XML_SOCKLEN_T_SIZE_T)
			set(XML_SOCKLEN_T size_t)
		else()
			check_c_source_compiles("
				#include <stddef.h>
				#include <sys/socket.h>
				#include <sys/types.h>
				int main() { (void) getsockopt (1, 1, 1, NULL, (int*) NULL); return 0; }
			" XML_SOCKLEN_T_INT)
			set(XML_SOCKLEN_T int)
		endif()
	endif()
	configure_file(config.h.cmake.in config.h)
endif()

set(
	LIBXML2_HDRS
	include/libxml/c14n.h
	include/libxml/catalog.h
	include/libxml/chvalid.h
	include/libxml/debugXML.h
	include/libxml/dict.h
	include/libxml/DOCBparser.h
	include/libxml/encoding.h
	include/libxml/entities.h
	include/libxml/globals.h
	include/libxml/hash.h
	include/libxml/HTMLparser.h
	include/libxml/HTMLtree.h
	include/libxml/list.h
	include/libxml/nanoftp.h
	include/libxml/nanohttp.h
	include/libxml/parser.h
	include/libxml/parserInternals.h
	include/libxml/pattern.h
	include/libxml/relaxng.h
	include/libxml/SAX.h
	include/libxml/SAX2.h
	include/libxml/schemasInternals.h
	include/libxml/schematron.h
	include/libxml/threads.h
	include/libxml/tree.h
	include/libxml/uri.h
	include/libxml/valid.h
	include/libxml/xinclude.h
	include/libxml/xlink.h
	include/libxml/xmlIO.h
	include/libxml/xmlautomata.h
	include/libxml/xmlerror.h
	include/libxml/xmlexports.h
	include/libxml/xmlmemory.h
	include/libxml/xmlmodule.h

=== debian/changelog ===
libxml2 (2.9.13+dfsg-1ubuntu0.10) jammy-security; urgency=medium

  * SECURITY UPDATE: libxslt internal memory corruption
    - debian/patches/CVE-2025-7425.patch: fix heap-use-after-free in
      xmlFreeID caused by atype corruption.
    - CVE-2025-7425

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 30 Oct 2025 09:31:20 -0400

libxml2 (2.9.13+dfsg-1ubuntu0.9) jammy-security; urgency=medium

  * SECURITY UPDATE: Stack overflow
    - debian/patches/CVE-2025-9714.patch: Make XPath depth check work with
      recursive invocations.
    - CVE-2025-9714

 -- Octavio Galland <octavio.galland@canonical.com>  Mon, 01 Sep 2025 12:56:38 -0300

libxml2 (2.9.13+dfsg-1ubuntu0.8) jammy-security; urgency=medium

  * SECURITY UPDATE: stack-based buffer overflow
    - debian/patches/CVE-2025-6021.patch: fix integer overflow by adding
      bound checks in xmlBuildQName in tree.c
      prevent integer overflow
    - debian/patches/CVE-2025-6170.patch: fix buffer overflow by adding
      bound checks in xmlShell in debugXML.c
    - CVE-2025-6021
    - CVE-2025-6170
  * SECURITY UPDATE: UAF and type confusion
    - debian/patches/CVE-2025-49794_49796.patch: fix UAF by returning node
      and freeing it after use; fix type confusion by adding type check in
      xmlSchematronFormatReport in schematron.c
    - CVE-2025-49794
    - CVE-2025-49796

 -- Shishir Subedi <shishir.subedi@canonical.com>  Sat, 09 Aug 2025 11:59:21 +0545

libxml2 (2.9.13+dfsg-1ubuntu0.7) jammy-security; urgency=medium

  * SECURITY UPDATE: OOB access in python API
    - debian/patches/CVE-2025-32414-pre1.patch: fix SAX driver with
      character streams in python/drv_libxml2.py.
    - debian/patches/CVE-2025-32414-1.patch: read at most len/4 characters
      in python/libxml.c.
    - debian/patches/CVE-2025-32414-2.patch: add a test in
      python/tests/Makefile.am, python/tests/unicode.py.
    - CVE-2025-32414
  * SECURITY UPDATE: heap under-read in xmlSchemaIDCFillNodeTables
    - debian/patches/CVE-2025-32415.patch: fix heap buffer overflow in
      xmlSchemaIDCFillNodeTables in xmlschemas.c.
    - CVE-2025-32415

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 24 Apr 2025 14:42:32 -0400

libxml2 (2.9.13+dfsg-1ubuntu0.6) jammy-security; urgency=medium

  * SECURITY UPDATE: use-after-free
    - debian/patches/CVE-2024-56171.patch: Fix use-after-free after
      xmlSchemaItemListAdd.
    - CVE-2024-56171
  * SECURITY UPDATE: stack-based buffer overflow
    - debian/patches/CVE-2025-24928-pre1.patch: Check for NULL node->name
      in xmlSnprintfElements.
    - debian/patches/CVE-2025-24928.patch: Fix stack-buffer-overflow in
      xmlSnprintfElements.
    - CVE-2025-24928
  * SECURITY UPDATE: NULL pointer dereference
    - debian/patches/CVE-2025-27113.patch: Fix compilation of explicit
      child axis.
    - CVE-2025-27113

 -- Fabian Toepfer <fabian.toepfer@canonical.com>  Fri, 21 Feb 2025 15:30:55 +0100

libxml2 (2.9.13+dfsg-1ubuntu0.5) jammy-security; urgency=medium

  * SECURITY UPDATE: use-after-free in xmlXIncludeAddNode
    - debian/patches/CVE-2022-49043.patch: fix UaF in xinclude.c.
    - CVE-2022-49043
  * SECURITY UPDATE: buffer overread in xmllint
    - debian/patches/CVE-2024-34459.patch: fix buffer issue when using
      htmlout option in xmllint.c.
    - CVE-2024-34459

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 28 Jan 2025 08:30:32 -0500

libxml2 (2.9.13+dfsg-1ubuntu0.4) jammy-security; urgency=medium

  * SECURITY UPDATE: use-after-free via XInclude expansion
    - debian/patches/CVE-2024-25062.patch: don't expand XIncludes when
      backtracking in xmlreader.c.
    - CVE-2024-25062

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 16 Feb 2024 13:14:24 -0500

libxml2 (2.9.13+dfsg-1ubuntu0.3) jammy-security; urgency=medium

  * SECURITY UPDATE: Null dereference
    - debian/patches/CVE-2023-28484-*.patch: Fix null-pointer-deref in
      xmlSchemaCheckCOSSTDerivedOK and xmlSchemaFixupComplexType
      when parsing (invalid) XML schemas in
      result/schemas/oss-fuzz-51295_0_0.err,
      test/schemas/oss-fuzz-51295_0.xml,
      test/schemas/oss-fuzz-51295_0.xsd,
      xmlschemas.c.
    - CVE-2023-28484
  * SECURITY UPDATE: Logic or memory errors and double frees
    - debian/patches/CVE-2023-29469.patch: check namelen less equal zero in
      dict.c.
    - CVE-2023-29469

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Fri, 14 Apr 2023 08:19:12 -0300

libxml2 (2.9.13+dfsg-1ubuntu0.2) jammy-security; urgency=medium

  * SECURITY UPDATE: NULL pointer dereference
    - debian/patches/CVE-2022-2309.patch: reset nsNr in
      xmlCtxReset in parser.c (LP: #1996494).
    - CVE-2022-2309
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2022-40303.patch: fix integer overflows
      with XML_PARSE_HUGE in parser.c.
    - CVE-2022-40303
  * SECURITY UPDATE: Double-free
    - debian/patches/CVE-2022-40304.patch: fix dict
      corruption caused by entity ref cycles in
      entities.c.
    - CVE-2022-40304

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Tue, 29 Nov 2022 16:39:07 -0300

=== debian/control ===
Source: libxml2
Priority: optional
Section: libs
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>
Uploaders:
 Aron Xu <aron@debian.org>,
 YunQiang Su <wzssyqa@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Indep:
 pkg-config,
Build-Depends-Arch:
 dh-sequence-python3 <!nopython>,
 libicu-dev,
 liblzma-dev,
 libpython3-all-dev <!nopython>,
 pkg-config,
 python3-all-dev:any (>= 3.5) <!nopython>,
 rename,
 zlib1g-dev | libz-dev,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: http://xmlsoft.org
Vcs-Git: https://salsa.debian.org/xml-sgml-team/libxml2.git
Vcs-Browser: https://salsa.debian.org/xml-sgml-team/libxml2
Description: GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.

Package: libxml2
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 w3c-dtd-xhtml,
Multi-Arch: same
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package provides a library providing an extensive API to handle
 such XML data files.

Package: libxml2-utils
Architecture: any
Section: text
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: foreign
Description: ${source:Synopsis} - utilities
 ${source:Extended-Description}
 .
 This package provides xmllint, a tool for validating and reformatting
 XML documents, and xmlcatalog, a tool to parse and manipulate XML or
 SGML catalog files.

Package: libxml2-dev
Architecture: any
Section: libdevel
Depends:
 libicu-dev,
 libxml2 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 pkg-config,
Multi-Arch: same
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 Install this package if you wish to develop your own programs using
 the GNOME XML library.

Package: libxml2-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Suggests:
 devhelp,
Multi-Arch: foreign
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package contains general information about the GNOME XML library
 and more specific API references.

Package: python3-libxml2
Architecture: any
Build-Profiles: <!nopython>
Section: python
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - Python3 bindings
 ${source:Extended-Description}
 .
 This package contains the files needed to use the GNOME XML library
 in Python3 programs.
